﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Globalization;

namespace Docking_TEST_SL
{
    public static class VisibilityHelper
    {
        public static string INVERTER_PARAMETER = "Invert";

        public static Visibility BoolToVisibility(object toConvert, object parameter)
        {
            bool boolValue = false;

            if (toConvert is bool)
                boolValue = (bool)toConvert;
            else if (toConvert is bool?)
            {
                var t_value = toConvert as bool?;
                if (t_value.HasValue)
                    boolValue = t_value.Value;
            }
            //else
            //  boolValue = ConvertHelper.ToBool(toConvert);

            if ((parameter != null) && (parameter.ToString() == VisibilityHelper.INVERTER_PARAMETER))
                boolValue = !boolValue;

            return boolValue ? Visibility.Visible : Visibility.Collapsed;
        }

        public static bool VisibilityToBool(object toConvert, object parameter)
        {
            if ((parameter != null) && (parameter.ToString() == INVERTER_PARAMETER))
            {
                if (toConvert is Visibility)
                    return (Visibility)toConvert != Visibility.Visible;
                else
                    return false;
            }
            else
            {
                if (toConvert is Visibility)
                    return (Visibility)toConvert == Visibility.Visible;
                else
                    return false;
            }
        }
    }

    /// <summary>
    /// Permet les binding entre visibility et boolean
    /// </summary>
    public class BooleanToVisibilityConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return VisibilityHelper.BoolToVisibility(value, parameter);
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return VisibilityHelper.VisibilityToBool(value, parameter);
        }
    }

}
